<template>
  <basic-container>
    <avue-crud :option="option"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.post_delete"
                   @click="handleDelete">删 除
        </el-button>
        <el-button type="success"
                   size="small"
                   plain
                   icon="el-icon-upload2"
                   @click="handleImport">导入
        </el-button>
        <el-button type="warning"
                   size="small"
                   plain
                   icon="el-icon-download"
                   @click="handleExport">导出
        </el-button>
      </template>
      <template slot-scope="{row}"
                slot="category">
        <el-tag>{{row.categoryName}}</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import {getList, getDetail, add, update, remove} from "@/api/system/post";
import {mapGetters} from "vuex";

export default {
  data() {
    return {
      form: {},
      query: {},
      loading: true,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      option: {
        height: 'auto',
        calcHeight: 30,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        viewBtn: true,
        selection: true,
        dialogType: "drawer",
        dialogClickModal: false,
        column: [
          {
            "type": 'year',
            "label": '年度',
            "span": 24,
            "display": true,
            "format": 'yyyy',
            "valueFormat": 'yyyy',
            "prop": 'a165101981736047159',
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "姓名必须填写"
              }
            ]
          },
          {
            "label": "姓名",
            "prop": "a165096433969376570",
            "type": "input",
            "span": 12,
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "姓名必须填写"
              }
            ]
          },
          {
            "label": "单位部门",
            "prop": "a165096466387727133",
            "type": "select",
            "span": 12,
            "dicData": [
              {
                "label": "信息技术处",
                "value": "0"
              },
              {
                "label": "政治部",
                "value": "1"
              },
              {
                "label": "人事警务处",
                "value": "2"
              }
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "单位部门必须填写"
              }
            ]
          },
          {
            "label": "职务",
            "prop": "a165096472711859053",
            "type": "select",
            "span": 12,
            "dicData": [
              {
                "label": "处长",
                "value": "0"
              },
              {
                "label": "副处长",
                "value": "1"
              },
              {
                "label": "员工",
                "value": "2"
              }
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "职务必须填写"
              }
            ]
          },
          {
            "label": "班次名称",
            "prop": "a165096490045292591",
            "type": "input",
            "span": 12,
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "班次名称必须填写"
              }
            ]
          },
          {
            "label": "培训学时",
            "prop": "a165096490598868493",
            "type": "input",
            "span": 12,
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "培训学时必须填写"
              }
            ]
          },
          {
            "label": "参训时间",
            "prop": "a165096494664553122",
            "type": "date",
            "span": 12,
            "format": "yyyy-MM-dd",
            "valueFormat": "yyyy-MM-dd",
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "参训时间必须填写"
              }
            ]
          },
          {
            "label": "办班部门",
            "prop": "a16509649734202074",
            "type": "input",
            "span": 24,
            "display": true
          }
        ]
      },
      data: [
        {
          a165101981736047159: '2022',
          a165096433969376570: '王老师',
          a165096466387727133: '信息技术处',
          a165096472711859053: '员工',
          a165096490045292591: '2022年度全员培训',
          a165096490598868493: '10',
          a165096494664553122: '2022-03-07',
          a16509649734202074: '人事警务部',
        },
        {
          a165101981736047159: '2022',
          a165096433969376570: '李老师',
          a165096466387727133: '信息技术处',
          a165096472711859053: '员工',
          a165096490045292591: '2022年度全员培训',
          a165096490598868493: '10',
          a165096494664553122: '2022-03-07',
          a16509649734202074: '人事警务部',
        },
        {
          a165101981736047159: '2022',
          a165096433969376570: '赵老师',
          a165096466387727133: '信息技术处',
          a165096472711859053: '员工',
          a165096490045292591: '2022年度全员培训',
          a165096490598868493: '10',
          a165096494664553122: '2022-03-07',
          a16509649734202074: '人事警务部',
        },
        {
          a165101981736047159: '2022',
          a165096433969376570: '陈老师',
          a165096466387727133: '信息技术处',
          a165096472711859053: '员工',
          a165096490045292591: '2022年度全员培训',
          a165096490598868493: '10',
          a165096494664553122: '2022-03-07',
          a16509649734202074: '人事警务部',
        }
      ]
    };
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList() {
      return {
        addBtn: this.vaildData(this.permission.post_add, false),
        viewBtn: this.vaildData(this.permission.post_view, false),
        delBtn: this.vaildData(this.permission.post_delete, false),
        editBtn: this.vaildData(this.permission.post_edit, false)
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    rowSave(row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowUpdate(row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        });
    },
    handleDelete() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          this.$refs.crud.toggleSelection();
        });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset() {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange(currentPage) {
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize) {
      this.page.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    }
  }
};
</script>

<style>
</style>
